diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
index c30ab97cf..5f37c90d0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
@@ -1,5 +1,9 @@
 package net.minecraft.client.gui;
 
+import net.minecraft.client.gui.keyboard.ScreenKeyboard;
+import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
+import net.minecraft.client.input.InputType;
+import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntitySign;
@@ -14,11 +18,12 @@ import org.lwjgl.opengl.GL11;
 
 public class ScreenSignEditor extends Screen
 {
-    public ScreenSignEditor(TileEntitySign tileentitysign)
+    private boolean inKeyboard = false;
+    public ScreenSignEditor(TileEntitySign sign)
     {
         screenTitle = I18n.getInstance().translateKey("gui.edit_sign.label.title");
         editLine = 0;
-        entitySign = tileentitysign;
+        entitySign = sign;
     }
 
     @Override
@@ -37,6 +42,17 @@ public class ScreenSignEditor extends Screen
         
         buttons.add(new ButtonElement(1, width / 2 - 20, 120 + 50 + yOffset, 20, 20, "<"));
         buttons.add(new ButtonElement(2, width / 2, 120 + 50 + yOffset, 20, 20, ">"));
+
+        add(new ListenerButtonElement(30, width/2 - 50, 12 * 0 + 67 + ((entitySign.getBlockId() == Blocks.SIGN_WALL_PLANKS_OAK.id()) ? 31 : 0), 100, 12, "")
+            .setActionListener(() -> {editLine = 0; inKeyboard = true;})).mute().hide();
+        add(new ListenerButtonElement(30, width/2 - 50, 12 * 1 + 67 + ((entitySign.getBlockId() == Blocks.SIGN_WALL_PLANKS_OAK.id()) ? 31 : 0), 100, 12, "")
+            .setActionListener(() -> {editLine = 1;inKeyboard = true;})).mute().hide();
+        add(new ListenerButtonElement(30, width/2 - 50, 12 * 2 + 67 + ((entitySign.getBlockId() == Blocks.SIGN_WALL_PLANKS_OAK.id()) ? 31 : 0), 100, 12, "")
+            .setActionListener(() -> {editLine = 2;inKeyboard = true;})).mute().hide();
+        add(new ListenerButtonElement(30, width/2 - 50, 12 * 3 + 67 + ((entitySign.getBlockId() == Blocks.SIGN_WALL_PLANKS_OAK.id()) ? 31 : 0), 100, 12, "")
+            .setActionListener(() -> {editLine = 3;inKeyboard = true;})).mute().hide();
+
+        inKeyboard = (mc.gameSettings.forceOnscreenKeyboard.value || mc.inputType == InputType.CONTROLLER) && !(mc.currentScreen instanceof ScreenKeyboard);
     }
 
     @Override
@@ -95,15 +111,15 @@ public class ScreenSignEditor extends Screen
             entitySign.setChanged();
     		mc.displayScreen(null);
     	}
-        if(eventKey == 200)
+        if(eventKey == Keyboard.KEY_UP)
         {
             editLine = editLine - 1 & 3;
         }
-        if(eventKey == 208 || eventKey == 28 || eventKey == 156)
+        if(eventKey == Keyboard.KEY_DOWN || eventKey == Keyboard.KEY_PRINT_SCREEN || eventKey == Keyboard.KEY_NUMPADENTER)
         {
             editLine = editLine + 1 & 3;
         }
-        if(eventKey == 14 && entitySign.signText[editLine].length() > 0)
+        if(eventKey == Keyboard.KEY_BACK && !entitySign.signText[editLine].isEmpty())
         {
             entitySign.signText[editLine] = entitySign.signText[editLine].substring(0, entitySign.signText[editLine].length() - 1);
         }
@@ -116,6 +132,24 @@ public class ScreenSignEditor extends Screen
     @Override
 	public void render(int mx, int my, float partialTick)
     {
+        if (inKeyboard && (mc.gameSettings.forceOnscreenKeyboard.value || mc.inputType == InputType.CONTROLLER) && !(mc.currentScreen instanceof ScreenKeyboard)) {
+            if (editLine < entitySign.signText.length) {
+                ScreenKeyboard keyboard = new ScreenKeyboard(this, null,
+                    (s) -> {
+                        entitySign.signText[editLine] = s;
+                        if (editLine < entitySign.signText.length - 1) {
+                            editLine++;
+                        } else {
+                            inKeyboard = false;
+                        }
+                    },
+                    (c, k, s) -> entitySign.signText[editLine] = s,
+                    s -> entitySign.signText[editLine] = s);
+                keyboard.editor.setText(entitySign.signText[editLine]);
+                keyboard.editor.setCursor(Integer.MAX_VALUE);
+                mc.displayScreen(keyboard);
+            }
+        }
         renderBackground();
         drawStringCentered(font, screenTitle, width / 2, 40, 0xffffff);
         GL11.glPushMatrix();
@@ -161,6 +195,17 @@ public class ScreenSignEditor extends Screen
         super.render(mx, my, partialTick);
     }
 
+    @Override
+    public void guiSpecificControllerInput(ControllerInput controller) {
+        super.guiSpecificControllerInput(controller);
+        if (controller.digitalPad.up.pressedThisFrame()) {
+            editLine = editLine - 1 & 3;
+        }
+        if (controller.digitalPad.down.pressedThisFrame()) {
+            editLine = editLine + 1 & 3;
+        }
+    }
+
     protected String screenTitle;
     private TileEntitySign entitySign;
     private int updateCounter;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java b/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java
index e70d408e5..c5f4a9852 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TextFieldElement.java
@@ -1,7 +1,11 @@
 package net.minecraft.client.gui;
 
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.keyboard.ScreenKeyboard;
 import net.minecraft.client.gui.text.TextFieldEditor;
+import net.minecraft.client.input.InputType;
 import net.minecraft.client.render.Font;
+import net.minecraft.client.render.window.CursorShape;
 import org.lwjgl.input.Keyboard;
 
 import net.minecraft.client.gui.text.ITextField;
@@ -86,13 +90,21 @@ public class TextFieldElement extends Gui implements ITextField
 
     public void mouseClicked(int x, int y, int mouseButton)
     {
-        boolean flag = isEnabled && x >= xPosition && x < xPosition + width && y >= yPosition && y < yPosition + height;
-        setFocused(flag);
-        if(flag && mouseButton == 1) {
-        	setText("");
+        boolean hovered = isHovered(x, y);
+        if (((Minecraft.getMinecraft().inputType == InputType.CONTROLLER || Minecraft.getMinecraft().gameSettings.forceOnscreenKeyboard.value) && hovered && mouseButton == 0)) {
+            parent.mc.displayScreen(new ScreenKeyboard(parent, editor, s -> {}, (c, k, workingString) -> {}, s -> {}));
+        } else {
+            setFocused(hovered);
+            if(hovered && mouseButton == 1) {
+                setText("");
+            }
         }
     }
 
+    public boolean isHovered(int x, int y) {
+        return isEnabled && x >= xPosition && x < xPosition + width && y >= yPosition && y < yPosition + height;
+    }
+
     public void setFocused(boolean flag)
     {
         if(flag && !isFocused)
@@ -103,6 +115,13 @@ public class TextFieldElement extends Gui implements ITextField
         isFocused = flag;
     }
 
+    public void updateCursor(Minecraft mc, int mx, int my) {
+        boolean hovered = isEnabled && mx >= xPosition && mx < xPosition + width && my >= yPosition && my < yPosition + height;
+        if (hovered) {
+            mc.currentScreen.setDesiredCursor(CursorShape.I_BEAM);
+        }
+    }
+
     public void drawTextBox()
     {
         if (drawBackground)
@@ -140,7 +159,7 @@ public class TextFieldElement extends Gui implements ITextField
                     // width of the text box - the width of the last character
                     width = (this.width-4) - font.getStringWidth(text.substring(text.length()-2,text.length()-1));
                 }
-                drawString(font, "_", xPosition + 4 + width, yPosition + (height - 8) / 2, 0xE0E0E0);
+                drawString(font, "_", xPosition + 4 + width, yPosition + (height - 8) / 2 + 1, 0xE0E0E0);
             }
         }
         else
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
index 99c688928..f6082c1c2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
@@ -13,6 +13,7 @@ import com.mojang.brigadier.suggestion.Suggestion;
 import com.mojang.brigadier.suggestion.Suggestions;
 import com.mojang.brigadier.tree.CommandNode;
 import com.mojang.brigadier.tree.LiteralCommandNode;
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.TooltipElement;
@@ -28,6 +29,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
+import org.slf4j.Logger;
 
 import java.awt.*;
 import java.util.ArrayList;
@@ -38,6 +40,7 @@ import java.util.concurrent.CompletableFuture;
 
 @SuppressWarnings({"OptionalGetWithoutIsPresent", "unused"})
 public class GuiElementChatSuggestions extends Gui {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private final TextFieldEditor editor;
     private final ITextField textField;
     private final Minecraft mc;
@@ -396,7 +399,12 @@ public class GuiElementChatSuggestions extends Gui {
         } else if (serverSuggestions.has(CommandManagerPacketKeys.SUGGESTION_CONTEXT_START_POS)) {
             return serverSuggestions.get(CommandManagerPacketKeys.SUGGESTION_CONTEXT_START_POS).getAsInt();
         }
-        return this.parseResults != null ? this.parseResults.getContext().findSuggestionContext(this.tablessCursor).startPos : 0;
+        try {
+            return this.parseResults != null ? this.parseResults.getContext().findSuggestionContext(this.tablessCursor).startPos : 0;
+        } catch (IllegalStateException e) {
+            LOGGER.error("", e);
+            return 0;
+        }
     }
 
     public void setAnchor(ComponentAnchor anchor) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
index 8fe6eb337..044ca43de 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
@@ -2,7 +2,9 @@ package net.minecraft.client.gui.chat;
 
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.hud.component.ComponentAnchor;
+import net.minecraft.client.gui.keyboard.ScreenKeyboard;
 import net.minecraft.client.gui.text.TextFieldEditor;
+import net.minecraft.client.input.InputType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.ChatEmotes;
 import org.lwjgl.input.Keyboard;
@@ -52,6 +54,19 @@ public class ScreenChat extends Screen implements ITextField {
 			this.suggestionsElement.updateSuggestions();
 		}
 
+		if (mc.gameSettings.forceOnscreenKeyboard.value || mc.inputType == InputType.CONTROLLER) {
+			suggestionsElement.hidden = true;
+			mc.displayScreen(new ScreenKeyboard(this, editor,
+				(workingString) -> sendMessage(),
+				(c, k, workingString) -> {
+					suggestionsElement.hidden = !getText().startsWith("/");
+					suggestionsElement.keyTyped(c, k);
+				},
+                s -> {
+					suggestionsElement.hidden = !getText().startsWith("/");
+					suggestionsElement.updateSuggestions();
+				}));
+		}
 	}
 
 	@Override
@@ -62,6 +77,10 @@ public class ScreenChat extends Screen implements ITextField {
 
 	@Override
 	public void tick() {
+		if ((mc.gameSettings.forceOnscreenKeyboard.value || mc.inputType == InputType.CONTROLLER) && !(mc.currentScreen instanceof ScreenKeyboard)) {
+			mc.displayScreen(null); // Close out of gui when exiting keyboard screen
+			return;
+		}
 		updateCounter++;
 
 		int dWheel = Mouse.getDWheel();
@@ -142,11 +161,7 @@ public class ScreenChat extends Screen implements ITextField {
 			handled = true;
 		}
 		if (eventKey == Keyboard.KEY_RETURN) {
-			String s = message.trim();
-			if (s.length() > 0) {
-				String s1 = message.trim();
-				mc.thePlayer.sendChatMessage(s1);
-			}
+			sendMessage();
 			mc.displayScreen(null);
 			handled = true;
 		}
@@ -158,6 +173,14 @@ public class ScreenChat extends Screen implements ITextField {
 		}
 	}
 
+	public void sendMessage() {
+		String s = message.trim();
+		if (s.length() > 0) {
+			String s1 = message.trim();
+			mc.thePlayer.sendChatMessage(s1);
+		}
+	}
+
 	@Override
 	public void render(int mx, int my, float partialTick) {
 		// Draw emote picker button
@@ -174,9 +197,9 @@ public class ScreenChat extends Screen implements ITextField {
 		drawRect(16, height - 14, width - 2, height - 2, 0x80000000);
 
 		font.drawStringWithShadow(this.suggestionsElement.getSuggestionPreview(), 16 + suggestionsElement.getDefaultParameterPosition(), mc.resolution.getScaledHeightScreenCoords() - 12, 0xFFFFFF);
+		drawString(font, this.suggestionsElement.colorCodeText(message, true), 18, height - 12, 0xE0E0E0);
 		boolean drawCursor = (updateCounter / 6) % 2 == 0;
 		int cursor = editor.getCursor();
-		drawString(font, this.suggestionsElement.colorCodeText(message, true), 18, height - 12, 0xE0E0E0);
 		if (drawCursor)
 		{
 			int width = font.getStringWidth(message);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java
index 7d79d3594..6b8c91681 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java
@@ -39,6 +39,7 @@ public class ScreenCrafting extends ScreenContainerAbstract
     }
     @Override
     public void guiSpecificControllerInput(ControllerInput controller){
+        super.guiSpecificControllerInput(controller);
         controller.inventoryHandler.handleCrafting(this);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
index 3963a4d40..450a74d81 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
@@ -59,6 +59,7 @@ public class ScreenFurnace extends ScreenContainerAbstract
     }
     @Override
     public void guiSpecificControllerInput(ControllerInput controller){
+        super.guiSpecificControllerInput(controller);
         controller.inventoryHandler.handleFurnace(this);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
index 02bdc5fac..72750dbf2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
@@ -13,6 +13,7 @@ import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
@@ -67,8 +68,8 @@ public class ScreenInventory extends ScreenContainerAbstract
     protected void checkForArmor(){
         boolean enableArmorButton = false;
 
-        for(int i=0; i < mc.thePlayer.inventory.armorInventory.length; i++) {
-            ItemStack itemStack = mc.thePlayer.inventory.armorItemInSlot(i);
+        for(int i = 0; i < mc.thePlayer.inventory.armorInventory.length; i++) {
+            ItemStack itemStack = mc.thePlayer.getItemInArmorSlot(HumanArmorShape.values()[i]);
             if(itemStack != null) {
                 enableArmorButton = true;
                 break;
@@ -211,7 +212,7 @@ public class ScreenInventory extends ScreenContainerAbstract
         	if(damageType.shouldDisplay()) {
         		int y2 = y + i * 10;
         		
-            	float protection = mc.thePlayer.inventory.getTotalProtectionAmount(damageType);
+            	float protection = mc.thePlayer.getTotalProtectionAmount(damageType);
             	if(protection > 1) protection = 1.0f;
 
                 int l = (int) (protection * 255);
@@ -237,7 +238,7 @@ public class ScreenInventory extends ScreenContainerAbstract
         glEnable(GL_TEXTURE_2D);
         
         if(hoveredDamageType != null) {
-        	int protection = Math.round(mc.thePlayer.inventory.getTotalProtectionAmount(hoveredDamageType) * 100);
+        	int protection = Math.round(mc.thePlayer.getTotalProtectionAmount(hoveredDamageType) * 100);
         	if(protection < 0) {
         		protection = 0;
         	}
@@ -303,6 +304,7 @@ public class ScreenInventory extends ScreenContainerAbstract
 
     @Override
     public void guiSpecificControllerInput(ControllerInput controller){
+        super.guiSpecificControllerInput(controller);
         controller.inventoryHandler.handleInventory(this);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
index 896f42783..15040ad0b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui.container;
 
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.TextFieldElement;
+import net.minecraft.client.gui.keyboard.ScreenKeyboard;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.entity.player.Player;
@@ -130,9 +131,14 @@ public class ScreenInventoryCreative extends ScreenInventory implements ITextCha
     	
     	updatePageSwitcher();
     }
-	
-    
-    @Override
+
+	@Override
+	public void render(int mx, int my, float partialTick) {
+		super.render(mx, my, partialTick);
+		searchField.updateCursor(mc, mx, my);
+	}
+
+	@Override
 	public void mouseClicked(int mx, int my, int buttonNum)
     {
         super.mouseClicked(mx, my, buttonNum);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java b/game/client/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
index a35ff3e37..c4c869d85 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
@@ -6,6 +6,7 @@ import net.minecraft.client.gui.paged.CallbackComponent;
 import net.minecraft.client.gui.paged.OnValueChangedCallback;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.lang.I18n;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
@@ -62,6 +63,7 @@ public class TextFieldComponent
         textField.xPosition = x + width - BUTTON_WIDTH;
         textField.yPosition = y + COMPONENT_SPACING + 1;
         textField.drawTextBox();
+        textField.updateCursor(mc, x + relativeMouseX, y + relativeMouseY);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
index 80f2f2dca..168366009 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
@@ -317,6 +317,7 @@ public class ScreenGuidebook
     }
 
     public void guiSpecificControllerInput(ControllerInput controller){
+        super.guiSpecificControllerInput(controller);
         if (controller.digitalPad.left.pressedThisFrame() || (controller.digitalPad.left.isPressed() && controller.digitalPad.left.getHoldTime() % 4 == 0)){
             guidebookPageManager.offsetPage(-2);
             updateTabList();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
index 4d8c02cea..cf2b49f1e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
@@ -88,6 +88,13 @@ public abstract class MobInfoRegistry {
             -1,
             null
         );
+        register(MobButterfly.class,
+            "guidebook.section.mob.butterfly.name",
+            "guidebook.section.mob.butterfly.desc",
+            -1,
+            -1,
+            null
+        );
         register(MobZombie.class,
             "guidebook.section.mob.zombie.name",
             "guidebook.section.mob.zombie.desc",
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/search/GuidebookPageSearch.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/search/GuidebookPageSearch.java
index 2fdab1459..bfc866176 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/search/GuidebookPageSearch.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/search/GuidebookPageSearch.java
@@ -26,6 +26,7 @@ public class GuidebookPageSearch extends GuidebookPage {
         searchClearButton.xPosition = searchField.xPosition + searchField.width + 5;
         searchClearButton.yPosition = searchField.yPosition;
         searchField.drawTextBox();
+        searchField.updateCursor(mc, mouseX, mouseY);
         searchClearButton.drawButton(mc,mouseX,mouseY);
 
         int results = 0;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 451f452ba..3091bc47e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -18,6 +18,7 @@ import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.enums.ChatVisibility;
+import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.util.helper.Direction;
 import org.lwjgl.opengl.GL11;
@@ -105,7 +106,7 @@ public class HudIngame extends Gui
         }
 
         // Render pumpkin overlay
-        ItemStack headSlotItem = mc.thePlayer.inventory.armorItemInSlot(IArmorItem.PIECE_HEAD);
+        ItemStack headSlotItem = mc.thePlayer.getItemInArmorSlot(HumanArmorShape.HEAD);
         if (mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && (headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id() || headSlotItem.itemID == Blocks.PUMPKIN_REDSTONE.id()))
         {
             renderPumpkinBlur(width, height);
@@ -514,9 +515,9 @@ public class HudIngame extends Gui
 
         if (mc.gameSettings.immersiveMode.drawOverlays() && mc.gameSettings.armorDurabilityOverlay.value)
         {
-            for (int i = 0; i < 4; i++)
+            for (int i = mc.thePlayer.getNumArmorSlots() - 1; i >= 0; i--)
             {
-                ItemStack stack = mc.thePlayer.inventory.armorInventory[IArmorItem.PIECE_HEAD - i];
+                ItemStack stack = mc.thePlayer.getItemInArmorSlot(HumanArmorShape.values()[i]);
 
                 if (stack != null)
                 {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
index f4c306854..5d31bc3be 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
@@ -4,6 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.command.TextFormatting;
@@ -46,7 +47,7 @@ public class HudIngameDoom
         }
 
         // Render pumpkin overlay
-        ItemStack headSlotItem = mc.thePlayer.inventory.armorItemInSlot(IArmorItem.PIECE_HEAD);
+        ItemStack headSlotItem = mc.thePlayer.getItemInArmorSlot(HumanArmorShape.HEAD);
         if (mc.gameSettings.thirdPersonView.value == 0 && headSlotItem != null && (headSlotItem.itemID == Blocks.PUMPKIN_CARVED_IDLE.id() || headSlotItem.itemID == Blocks.PUMPKIN_REDSTONE.id()))
         {
             renderPumpkinBlur(width, height);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
index d7c10821e..d4f529d98 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
@@ -24,6 +24,10 @@ public abstract class HudComponent {
 
     public abstract boolean isVisible(Minecraft mc);
 
+    public boolean isEnabled(Minecraft mc) {
+        return true;
+    }
+
     public String getKey() {
         return key;
     }
